<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AllocationDialog xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/ui/dialogs/AllocationDialog.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.ui.dialogs;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.draw2d.Label;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.transaction.util.TransactionUtil;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.workspace.AbstractEMFOperation;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.MessageDialog;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.MARTE.MARTE_DesignModel.SRM.SW_Concurrency.SwSchedulableResource;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.DeploymentPlan;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.AllocUtils;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.ElementFilter;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CommandSupport;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.commands.AddMarteAndFcmProfile;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.toolbox.utils.DialogUtils;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionAdapter;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionEvent;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.layout.GridData;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Combo;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Control;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Tree;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.TreeColumn;
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.TreeItem;
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <strong class="jxr_keyword">import</strong> org.eclipse.ui.dialogs.SelectionStatusDialog;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment"> * Allocate elements in a deployment plan to a node or thread</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/ui/dialogs/AllocationDialog.html">AllocationDialog</a> <strong class="jxr_keyword">extends</strong> SelectionStatusDialog {
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<strong class="jxr_keyword">protected</strong> Package m_cdp;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<strong class="jxr_keyword">private</strong> Tree fTree;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	<strong class="jxr_keyword">private</strong> Label fLabel;
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  	<strong class="jxr_keyword">private</strong> Combo fAlloc;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<strong class="jxr_keyword">private</strong> InstanceSpecification currentIS;
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<strong class="jxr_keyword">private</strong> EList&lt;InstanceSpecification&gt; nodeOrThreadList;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/ui/dialogs/AllocationDialog.html">AllocationDialog</a>(Shell parent, Package cdp) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		<strong class="jxr_keyword">super</strong>(parent);
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		m_cdp = cdp;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		nodeOrThreadList = <strong class="jxr_keyword">new</strong> BasicEList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		nodeOrThreadList.add(<strong class="jxr_keyword">null</strong>); <em class="jxr_comment">// dummy entry for no allocation</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		DepUtils.getAllInstances(cdp.getModel(), nodeOrThreadList, <strong class="jxr_keyword">new</strong> ElementFilter() {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			@Override
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> acceptElement(Element element) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  				<strong class="jxr_keyword">if</strong> (element instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  					InstanceSpecification instance = (InstanceSpecification) element;
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  					<strong class="jxr_keyword">if</strong> (instance.getName() == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  						<em class="jxr_comment">// don't allocate to root element (detectable via the empty name)</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  						<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  					}
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  					Classifier cl = DepUtils.getClassifier(instance);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  					<strong class="jxr_keyword">if</strong> (cl instanceof Class) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  						<strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(cl, SwSchedulableResource.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  							<em class="jxr_comment">// threads are valid allocation targets. Therefore, threads are always added to</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  							<em class="jxr_comment">// list, even if within a deployment plan.</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  							<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  						}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	                   <strong class="jxr_keyword">if</strong> (StereotypeUtil.isApplied(instance.getNearestPackage(), DeploymentPlan.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>                              <em class="jxr_comment">// instance is part of a deployment plan =&gt; don't add to list.</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>                              <strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L95" href="#L95">95</a>                          }
<a class="jxr_linenumber" name="L96" href="#L96">96</a>                          <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  					}
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  				}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  				<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		});
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	}
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 * @see SelectionStatusDialog#computeResult()</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 	@Override
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> computeResult() {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// nothing to do</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 	}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	@Override
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	<strong class="jxr_keyword">public</strong> Control createDialogArea(Composite parent) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		Composite contents = (Composite) <strong class="jxr_keyword">super</strong>.createDialogArea(parent);
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<em class="jxr_comment">// (parent, "Container rules", "Avail. extensions/interceptors");</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		fTree = <strong class="jxr_keyword">new</strong> Tree(contents, SWT.H_SCROLL | SWT.BORDER);
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		fTree.setHeaderVisible(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		GridData data = <strong class="jxr_keyword">new</strong> GridData(GridData.FILL_BOTH);
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		fTree.setLayoutData(data);
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		data.heightHint = 150;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		<em class="jxr_comment">// data.widthHint = 200;</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		<em class="jxr_comment">// Turn off drawing to avoid flicker</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		fTree.setRedraw(false);
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		TreeColumn instances = <strong class="jxr_keyword">new</strong> TreeColumn(fTree, SWT.LEFT);
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		instances.setText(<span class="jxr_string">"Instance"</span>);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		instances.setWidth(200);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		TreeColumn explicitAlloc = <strong class="jxr_keyword">new</strong> TreeColumn(fTree, SWT.LEFT);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		explicitAlloc.setText(<span class="jxr_string">"explicit allocation"</span>);
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		explicitAlloc.setWidth(150);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		TreeColumn implicitAlloc = <strong class="jxr_keyword">new</strong> TreeColumn(fTree, SWT.LEFT);
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		implicitAlloc.setText(<span class="jxr_string">"implicit allocation"</span>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		implicitAlloc.setWidth(150);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification is : DepUtils.getTopLevelInstances(m_cdp)) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			fillTree(fTree, <strong class="jxr_keyword">null</strong>, is);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		<em class="jxr_comment">// Turn drawing back on!</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		fTree.setRedraw(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		fTree.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionAdapter() {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			@Override
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 				<strong class="jxr_keyword">if</strong> (fTree.getSelection().length &gt; 0) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 					selectInstance(fTree.getSelection()[0]);
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 				}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 			}
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		});
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		Label label = <strong class="jxr_keyword">new</strong> Label();
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		label.setText(<span class="jxr_string">"seletected instance:"</span>);
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		fLabel = <strong class="jxr_keyword">new</strong> Label();
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		createAllocInfo(contents);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">return</strong> contents;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 	}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> <em class="jxr_javadoccomment">	 * Helper method to fill a tree with data</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> <em class="jxr_javadoccomment">	 * @param tree</em>
<a class="jxr_linenumber" name="L166" href="#L166">166</a> <em class="jxr_javadoccomment">	 *            the tree to fill</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> fillTree(Tree tree, TreeItem treeItem, InstanceSpecification is) {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		TreeItem item;
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 		<strong class="jxr_keyword">if</strong> (treeItem != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 			item = <strong class="jxr_keyword">new</strong> TreeItem(treeItem, SWT.NONE);
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 			item = <strong class="jxr_keyword">new</strong> TreeItem(tree, SWT.NONE);
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		}
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		item.setData(is);
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		setTextFromData(item);
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		<em class="jxr_comment">// create children</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification subIS : DepUtils.getContainedNonSharedInstances(is)) {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			fillTree(tree, item, subIS);
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 		}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 	}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 	<em class="jxr_comment">// obtain name and explicit/implicit node Allocation</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> setTextFromData(TreeItem ti) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		Object data = ti.getData();
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		<strong class="jxr_keyword">if</strong> (data instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 			InstanceSpecification is = (InstanceSpecification) data;
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			String name = is.getName();
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 			<strong class="jxr_keyword">int</strong> index = name.lastIndexOf(<span class="jxr_string">"."</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			<strong class="jxr_keyword">if</strong> (index != -1) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 				name = name.substring(index + 1);
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			}
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			InstanceSpecification explicitNodeOrThread = AllocUtils.getNodeOrThread(is);
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 			Classifier cl = DepUtils.getClassifier(is);
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			String nodeName;
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 			<strong class="jxr_keyword">if</strong> (explicitNodeOrThread == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 				nodeName = <span class="jxr_string">"-"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 				nodeName = getAllocName(explicitNodeOrThread);
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 			}
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 			<strong class="jxr_keyword">if</strong> (cl instanceof Class) {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 				<em class="jxr_comment">// if (BootLoaderGen.hasUnconnectedStartRoutine(null, (Class) cl, null)) {</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 				<em class="jxr_comment">// TODO</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 					nodeName += <span class="jxr_string">" (main)"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 				<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 			}
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 			EList&lt;InstanceSpecification&gt; implicitNodes = AllocUtils.getAllNodesOrThreadsParent(is);
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			implicitNodes.addAll(AllocUtils.getAllNodesOrThreadsParent(is));
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 			String list = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 			<strong class="jxr_keyword">for</strong> (InstanceSpecification node : implicitNodes) {
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 				<strong class="jxr_keyword">if</strong> (list.equals(<span class="jxr_string">""</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 					list = getAllocName(node);
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 				} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 					list += <span class="jxr_string">", "</span> + getAllocName(node); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 				}
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			}
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			ti.setText(<strong class="jxr_keyword">new</strong> String[] { name, nodeName, <span class="jxr_string">"["</span> + list + <span class="jxr_string">"]"</span> }); <em class="jxr_comment">//$NON-NLS-1$//$NON-NLS-2$</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	}
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> refreshTree(TreeItem ti) {
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 		setTextFromData(ti);
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		<strong class="jxr_keyword">for</strong> (TreeItem subItem : ti.getItems()) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 			refreshTree(subItem);
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 		}
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 	}
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 	<strong class="jxr_keyword">private</strong> String getAllocName(InstanceSpecification nodeOrThread) {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 		<strong class="jxr_keyword">if</strong> (nodeOrThread == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 			<strong class="jxr_keyword">return</strong> <span class="jxr_string">"no explicit allocation"</span>;
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 			String name = nodeOrThread.getName();
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 			InstanceSpecification threadNode = AllocUtils.getNode(nodeOrThread);
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			<strong class="jxr_keyword">return</strong> name + (threadNode != <strong class="jxr_keyword">null</strong> ? <span class="jxr_string">" on "</span> + threadNode.getName() : <span class="jxr_string">""</span>);
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 	}
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createAllocInfo(Composite parent) {
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 		<em class="jxr_comment">// create extension kind combo</em>
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		fAlloc = DialogUtils.createComboWithText(parent, <span class="jxr_string">"Alloc to node:"</span>,
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 				SWT.DROP_DOWN | SWT.READ_ONLY, SWT.NONE);
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 		String items[] = <strong class="jxr_keyword">new</strong> String[nodeOrThreadList.size()];
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		<strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 		<strong class="jxr_keyword">for</strong> (InstanceSpecification nodeOrThread : nodeOrThreadList) {
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 			items[i++] = getAllocName(nodeOrThread);
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 		}
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 		fAlloc.setItems(items);
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 		fAlloc.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionAdapter() {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			@Override
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent event) {
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 				<strong class="jxr_keyword">if</strong> (currentIS != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 					updateAllocation(currentIS, fAlloc.getSelectionIndex());
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 					<em class="jxr_comment">// selectionCount should always be 1</em>
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 					<strong class="jxr_keyword">for</strong> (TreeItem ti : fTree.getSelection()) {
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 						refreshTree(ti);
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 					}
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 				}
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 			}
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 		});
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 		fAlloc.setEnabled(false);
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 	}
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L269" href="#L269">269</a> <em class="jxr_javadoccomment">	 * Select a rule, i.e. update the visual representation from the rule</em>
<a class="jxr_linenumber" name="L270" href="#L270">270</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L271" href="#L271">271</a> <em class="jxr_javadoccomment">	 * @param rule</em>
<a class="jxr_linenumber" name="L272" href="#L272">272</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> selectInstance(TreeItem item) {
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		<em class="jxr_comment">// for (Port port : rule.getPortSet ()) {</em>
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 		<em class="jxr_comment">// fPorts.setSelection()</em>
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 		<em class="jxr_comment">// }</em>
<a class="jxr_linenumber" name="L277" href="#L277">277</a> 		currentIS = (InstanceSpecification) item.getData();
<a class="jxr_linenumber" name="L278" href="#L278">278</a> 		fLabel.setText(currentIS.getName());
<a class="jxr_linenumber" name="L279" href="#L279">279</a> 
<a class="jxr_linenumber" name="L280" href="#L280">280</a> 		fAlloc.setEnabled(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L281" href="#L281">281</a> 		InstanceSpecification nodeOrThread = AllocUtils.getNodeOrThread(currentIS);
<a class="jxr_linenumber" name="L282" href="#L282">282</a> 
<a class="jxr_linenumber" name="L283" href="#L283">283</a> 		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; nodeOrThreadList.size(); i++) {
<a class="jxr_linenumber" name="L284" href="#L284">284</a> 			<strong class="jxr_keyword">if</strong> (nodeOrThreadList.get(i) == nodeOrThread) {
<a class="jxr_linenumber" name="L285" href="#L285">285</a> 				fAlloc.select(i);
<a class="jxr_linenumber" name="L286" href="#L286">286</a> 			}
<a class="jxr_linenumber" name="L287" href="#L287">287</a> 		}
<a class="jxr_linenumber" name="L288" href="#L288">288</a> 	}
<a class="jxr_linenumber" name="L289" href="#L289">289</a> 
<a class="jxr_linenumber" name="L290" href="#L290">290</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> updateAllocation(InstanceSpecification is, <strong class="jxr_keyword">int</strong> index) {
<a class="jxr_linenumber" name="L291" href="#L291">291</a> 		InstanceSpecification oldNode = AllocUtils.getNodeOrThread(is);
<a class="jxr_linenumber" name="L292" href="#L292">292</a> 		InstanceSpecification newNode = nodeOrThreadList.get(index);
<a class="jxr_linenumber" name="L293" href="#L293">293</a> 
<a class="jxr_linenumber" name="L294" href="#L294">294</a> 		<strong class="jxr_keyword">if</strong> (oldNode == newNode) {
<a class="jxr_linenumber" name="L295" href="#L295">295</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L296" href="#L296">296</a> 		}
<a class="jxr_linenumber" name="L297" href="#L297">297</a> 
<a class="jxr_linenumber" name="L298" href="#L298">298</a> 		<em class="jxr_comment">// add or update</em>
<a class="jxr_linenumber" name="L299" href="#L299">299</a> 		<strong class="jxr_keyword">if</strong> (oldNode == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L300" href="#L300">300</a> 			<strong class="jxr_keyword">if</strong> (!AllocUtils.allocate(is, newNode)) {
<a class="jxr_linenumber" name="L301" href="#L301">301</a> 				<strong class="jxr_keyword">if</strong> (MessageDialog.openQuestion(Display.getDefault().getActiveShell(), <span class="jxr_string">"Error"</span>,
<a class="jxr_linenumber" name="L302" href="#L302">302</a> 						<span class="jxr_string">"Stereotype application failed. The profile MARTE::Allocation is probably not applied. Try to apply it?"</span>)) {
<a class="jxr_linenumber" name="L303" href="#L303">303</a> 					AbstractEMFOperation applyProfile = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/commands/AddMarteAndFcmProfile.html">AddMarteAndFcmProfile</a>(PackageUtil.getRootPackage(is), AddMarteAndFcmProfile.APPLY_ALLOC, TransactionUtil.getEditingDomain(is));
<a class="jxr_linenumber" name="L304" href="#L304">304</a> 					CommandSupport.exec(applyProfile);
<a class="jxr_linenumber" name="L305" href="#L305">305</a> 					AllocUtils.allocate(is, newNode);
<a class="jxr_linenumber" name="L306" href="#L306">306</a> 				}
<a class="jxr_linenumber" name="L307" href="#L307">307</a> 			}
<a class="jxr_linenumber" name="L308" href="#L308">308</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L309" href="#L309">309</a> 			AllocUtils.updateAllocation(is, oldNode, newNode);
<a class="jxr_linenumber" name="L310" href="#L310">310</a> 		}
<a class="jxr_linenumber" name="L311" href="#L311">311</a> 	}
<a class="jxr_linenumber" name="L312" href="#L312">312</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
